import java.util.Random;
import java.util.Timer;
import java.util.TimerTask;
import java.util.Vector;

import javax.microedition.lcdui.Canvas;
import javax.microedition.lcdui.Graphics;
import javax.microedition.lcdui.Image;

/**
 * @author Lucie Rt Bittnerov
 * 
 * Tda zodpovdn za prbh vlastn hry Blabouch
 */
public class GameCanvas extends Canvas {
	// perioda spoutn metody GameTask.run()
	private int tick = 80;
	// obrzek na pozad
	private Image background;
	// lo
	private GameSprite boat;
	// vbuch lodi
	private GameSprite explosion;
	// obrzky minc
	private Image[] coins = new Image[3];
	// obrzek bomby
	private Image bomb;
	// obrzek konce hry
	private Image end;
	// relativn posun lodi
	private int dx;
	// je-li true, lo se pohybuje, jinak stoj
	private boolean move = false;
	// je-li true, nastal konec hry
	private boolean gameOver = false;
	// 
	private boolean waiting = false;
	// vektor s bombami, kter jsou ve he
	private Vector bombs = new Vector();
	// vektor s mincemi hodnoty 1, kter jsou ve he
	private Vector ones = new Vector();
	// vektor s mincemi hodnoty 10, kter jsou ve he
	private Vector tens = new Vector();
	// vektor s mincemi hodnoty 100, kter jsou ve he
	private Vector hundreds = new Vector();
	// relativn posun vci (mince, bomby) 
	// v jednom kroku ve smru x-ov souadnice
	private int thingDx = 0;
	// relativn posun vci (mince, bomby) 
	// v jednom kroku ve smru y-ov souadnice
	private int thingDy = 3;
	// aktuln skre
	private int score = 0;
	// abstraktn pkazy "Konec" a "Hrt" 
	//private Command endCmd, playCmd;
	// genertor nhodnch sel
	private Random rand = new Random();
	// poet krok, za kter se vygeneruje dal vc (mince, bomba)
	private int nextThing = 5;
	// maximln poet krok, za kter se vygeneruje dal vc (mince, bomba)
	private int maxInterval = 30;
	// minimln poet krok, za kter se vygeneruje dal vc (mince, bomba)
	private int minInterval = 5;
	// asova kol
	private Timer timer;
	// kol asovae - v naem ppad instance tdy GameTask
	private TimerTask task;
	
	
	public GameCanvas(GameMIDlet midlet){
		try{
			// nahrn obrzk
			background = Image.createImage("/background.png");
			coins[0] = Image.createImage("/1.png");
			coins[1] = Image.createImage("/10.png");
			coins[2] = Image.createImage("/100.png");
			bomb = Image.createImage("/bomb.png");
			boat = new GameSprite(Image.createImage("/boat.png"));
			boat.setPosition(0, getHeight() - boat.getHeight() - 5);
			explosion = new GameSprite(Image.createImage("/explosion.png"));
			explosion.setVisible(false);
			end = Image.createImage("/end.png");
		} catch(Exception e){
			e.printStackTrace();
		}
		// vytvoen abstraktnch pkaz
		//endCmd = new Command("Konec", Command.EXIT, 1);
		//playCmd = new Command("Hrt", Command.SCREEN, 1);
		// pidme jen pkaz "Konec", protoe na zatku 
		// se hra spust automaticky
		//addCommand(endCmd);
		addCommand(GameMIDlet.backCmd);
		// nastaven posluchae udlost
		setCommandListener(midlet);
	}
	
	/**
	 * Inicializace podmnek pi sputn hry
	 *
	 */
	protected void init(){
		// zobrazen lodi
		boat.setVisible(true);
		// skryt exploze
		explosion.setVisible(false);
		// nastaven lodi na vchoz pozici
		boat.setPosition(0, getHeight() - boat.getHeight() - 5);
		// nastaven interval generovn vc
		maxInterval = 50;
		minInterval = 10;
		// vynulovn skre
		score = 0;
		// lo stoj
		move = false;
		// nen konec hry
		gameOver = false;
		waiting = false;
	}
	
	/**
	 * Skryt kanvasu hry: zapauzujeme hru
	 */
	protected void hideNotify(){
		if(timer!=null){
			timer.cancel();
			timer = null;
			task = null;
		}
	}
	
	/**
	 * Zobrazen kanvasu hry: obnovme hru
	 */
	protected void showNotify() {
		if(gameOver==false){
			task = new GameTask();
			timer = new Timer();
			timer.schedule(task, 0, tick);
		} 
	}
	
	/**
	 * Vykreslen kanvasu
	 */
	protected void paint(Graphics g) {
		// pekreslen displeje blou barvou
		g.setColor(0xffffff);
		g.fillRect(0,0,getWidth(), getHeight());
		// nakreslen pozad
		g.drawImage(background, 0, 0, Graphics.TOP | Graphics.LEFT);
		// nakreslen lodi
		boat.paint(g);
		// nakreslen exploze
		explosion.paint(g);
		// vykreslen vech vc (bomb, minc)
		int i=0;
		while(bombs.size()>i){
			((GameSprite)bombs.elementAt(i)).paint(g);
			i++;
		}
		i=0;
		while(hundreds.size()>i){
			((GameSprite)hundreds.elementAt(i)).paint(g);
			i++;
		}
		i=0;
		while(tens.size()>i){
			((GameSprite)tens.elementAt(i)).paint(g);
			i++;
		}
		i=0;
		while(ones.size()>i){
			((GameSprite)ones.elementAt(i)).paint(g);
			i++;
		}
		// nakreslen skre
		g.setColor(0x840400);
		g.drawString("" + score, 0, 2, Graphics.TOP | Graphics.LEFT);
		// nakreslen konce hry, je-li u konec
		if(gameOver){
			g.drawImage(end, getWidth()/2, getHeight()/2, Graphics.HCENTER | Graphics.VCENTER);
		}
	}
	
	/**
	 * stisk klvesy
	 */
	protected void keyPressed(int key) {
		/* Nastal-li konec hry, hra se opt spust stiskem
		 * libovoln klvesy.
		 */
		if(gameOver && !waiting){
			GameMIDlet.getInstance().menuAction();
			init();
			return;
		}
		
		/* zjitn hern akce odpovdajc kdu stisknut klvesy */
		int action = getGameAction(key);
		switch(action){
			case Canvas.LEFT: // pohyb lod doleva
				dx = -4;
				move = true;
				break;
			case Canvas.RIGHT: // pohyb lod doprava
				dx = 4;
				move = true;
				break;
		}
		
	}
	
	/**
	 * uvolnn klvesy
	 */
	public void keyReleased(int keyCode) {
		int action = this.getGameAction(keyCode);
		if (action == Canvas.LEFT
			|| action == Canvas.RIGHT) {
			// ukonen pohybu lodi
			move = false;
		}
	}
	
	public boolean isOver(){
		return gameOver;
	}

	/**
	 * kol asovae zodpovdn za periodicky opakovan akce hry
	 * Blabouch, jako je generovn bomb a minc a pohyb lod 
	 */
	class GameTask extends TimerTask {

		public void run() {
				// Pohnut lod, pokud uivatel dr klvesu doleva nebo doprava
				if(move){
					int newx = boat.getX() +  dx;
					if(newx<0){
						newx = 0;
					} else if (newx > getWidth() - boat.getWidth()){
						newx = getWidth() - boat.getWidth();
					}
					boat.move(newx - boat.getX(), 0);
				}
				// Pohnut vemi padajcmi pedmty
				int i = 0;
				while(i<bombs.size()){
					GameSprite vec = (GameSprite) bombs.elementAt(i);				
					vec.move(thingDx, thingDy);
					if(boat.collidesWith(vec, false)){
						// Bomba narazila do lodi -> konec hry
						boat.setVisible(false);
						explosion.setPosition(boat.getX()-(explosion.getWidth()- boat.getWidth())/2, boat.getY()-(explosion.getHeight()- boat.getHeight())/2);
						explosion.setVisible(true);
						//addCommand(playCmd);
						bombs.removeAllElements();
						hundreds.removeAllElements();
						tens.removeAllElements();
						ones.removeAllElements();
						task.cancel();
						task = null;
						gameOver = true;
						repaint();
						serviceRepaints();
						waiting = true;
						try{
							Thread.sleep(2000);
						}catch(Exception e){
							e.printStackTrace();
						}
						waiting = false;
						return;
					}
					if(vec.getY()>getHeight()){
						// Vc u je n ne okraj displeje
						bombs.removeElementAt(i);
					} else {
						i++;
					}
				}
				i = 0;
				while(i<hundreds.size()){
					GameSprite vec = (GameSprite) hundreds.elementAt(i);				
					vec.move(thingDx, thingDy);
					if(boat.collidesWith(vec, false)){
						// Vc narazila do lodi
						score += 100;
						vec.setPosition(0, getHeight() + 1);
					}
					if(vec.getY()>getHeight()){
						// Vc je mimo displeje
						hundreds.removeElementAt(i);
					} else {
						i++;
					}
				}
				i = 0;
				while(i<tens.size()){
					GameSprite vec = (GameSprite) tens.elementAt(i);				
					vec.move(thingDx, thingDy);
					if(boat.collidesWith(vec, false)){
						// Vc narazila do lodi
						score += 10;
						vec.setPosition(0, getHeight() + 1);
					}
					if(vec.getY()>getHeight()){
						// Vc u je n ne okraj displeje
						tens.removeElementAt(i);
					} else {
						i++;
					}
				}
				i = 0;
				while(i<ones.size()){
					GameSprite vec = (GameSprite) ones.elementAt(i);				
					vec.move(thingDx, thingDy);
					if(boat.collidesWith(vec, false)){
						// Vc narazila do lodi
						score += 1;
						vec.setPosition(0, getHeight() + 1);
					}
					if(vec.getY()>getHeight()){
						// Vc u je n ne okraj displeje
						ones.removeElementAt(i);
					} else {
						i++;
					}
				}
				// snen potu krok zbvajcch do vygenerovn dal vci
				nextThing--;
				if(nextThing==0){
					// vygenerovn vci
					int r = Math.abs(rand.nextInt()) % 4;
					Image rimage = null;
					switch(r){
						case 0: 
							rimage = bomb;
							break;
						case 1:
							rimage = coins[0];
							break;
						case 2:
							rimage = coins[1];
							break;
						case 3:
							rimage = coins[2];
							break;
					}
					// nhodn uren x-ov pozice vci
					int rx = Math.abs(rand.nextInt()) % (getWidth() - rimage.getWidth());
	                GameSprite vec = new GameSprite(rimage);
	                vec.setPosition(rx, 0);
	                // pidn nov vci do vektoru obsahujcho vci tho typu
					switch(r){
						case 0: 
							bombs.addElement(vec);
							break;
						case 1:
							ones.addElement(vec);
							break;
						case 2:
							tens.addElement(vec);
							break;
						case 3:
							hundreds.addElement(vec);
							break;
					}
					// uren potu krok do vygenerovn dal vci
	                nextThing = (Math.abs(rand.nextInt()) % (maxInterval-minInterval)) + minInterval;
				}
				// pekreslen displeje
				repaint();
				serviceRepaints();
		}

	}

	
}
