import javax.microedition.lcdui.Command;
import javax.microedition.lcdui.CommandListener;
import javax.microedition.lcdui.Display;
import javax.microedition.lcdui.Displayable;
import javax.microedition.lcdui.Form;
import javax.microedition.midlet.MIDlet;
import javax.microedition.midlet.MIDletStateChangeException;
/*
 * Created on 7.8.2004
 */

/**
 * @author Lucie Rt Bittnerov
 */
public class GameMIDlet extends MIDlet implements CommandListener{
	private GameCanvas canvas;
	private Displayable menu;
	private Displayable help;
	private boolean inited = false;
	
	private static GameMIDlet instance;

	public static final Command backCmd = new Command("Zpt", Command.BACK, 1);;
	
	public GameMIDlet(){
		super();
		instance = this;
	}
	
	/**
	 * @return vrt instanci tdy GameMIDlet
	 */
	public static GameMIDlet getInstance(){
		return instance;
	}
	
	protected void startApp() throws MIDletStateChangeException {		
		if(canvas==null){
			// Sputn aplikace
			SplashScreen splashScreen = new SplashScreen();
			Display.getDisplay(this).setCurrent(splashScreen);
			Thread t = 	new Thread(splashScreen);
			t.start();
			canvas = new GameCanvas(this);
			// zskn jmna implementace menu z deskriptoru aplikace
			String className = this.getAppProperty("menu-class");
			if(className==null){
				className = "MenuList";
			}
			try{
				// vytvoen instance tdy se jmnem className
				menu = (Displayable)Class.forName(className).newInstance();
			} catch (Exception e){
			}
			//menu = new MenuList(this);
			initHelp();
			inited = true;
		} else {
			// Aktivace aplikace po jejm pobytu v pasivnm stavu,
			// v naem ppad zde nen nic poteba dlat
		}	
	}
	
	/**
	 * @return true, je-li instance inicializovan, jinak false
	 */
	public boolean isInited(){
		return inited;
	}
	
	protected void pauseApp() {
	}

	protected void destroyApp(boolean arg0) {
		notifyDestroyed();
	}
	
	/**
	 * Zobraz vlastn hru
	 *
	 */
	public void playAction(){
		if(canvas.isOver()){
			canvas.init();
		}
		Display.getDisplay(this).setCurrent(canvas);
	}
	
	/**
	 * Zobraz menu
	 *
	 */
	public void menuAction(){
		Display.getDisplay(this).setCurrent(menu);
	}
	
	/**
	 * Zobraz npovdu
	 *
	 */
	public void helpAction(){
		Display.getDisplay(this).setCurrent(help);
	}

	/**
	 * Inicializuje npovdu
	 *
	 */
	protected void initHelp(){
		Form help = new Form("Npovda");
		help.append("ipkami jezdte lod doleva a doprava, vyhbejte se bombm a chytejte penze.");
		help.addCommand(backCmd);
		help.setCommandListener(this);
		this.help = help;
	}
	
	public void commandAction(Command c, Displayable d){
		if(d==help && c==backCmd){
			menuAction();
		} else if (d==canvas && c==backCmd){
			menuAction();
		}
		
	}
}
